/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.liferay.chat.service.persistence;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;

/**
 * @author Brian Wing Shun Chan
 */
public class StatusFinderUtil {
	public static java.util.List<java.lang.Object[]> findByModifiedDate(
		long companyId, long userId, long modifiedDate, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getFinder()
				   .findByModifiedDate(companyId, userId, modifiedDate, start,
			end);
	}

	public static java.util.List<java.lang.Object[]> findBySocialRelationType(
		long userId, int type, long modifiedDate, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getFinder()
				   .findBySocialRelationType(userId, type, modifiedDate, start,
			end);
	}

	public static java.util.List<java.lang.Object[]> findByUsersGroups(
		long userId, long modifiedDate, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getFinder().findByUsersGroups(userId, modifiedDate, start, end);
	}

	public static StatusFinder getFinder() {
		if (_finder == null) {
			_finder = (StatusFinder)PortletBeanLocatorUtil.locate(com.liferay.chat.service.ClpSerializer.SERVLET_CONTEXT_NAME,
					StatusFinder.class.getName());
		}

		return _finder;
	}

	public void setFinder(StatusFinder finder) {
		_finder = finder;
	}

	private static StatusFinder _finder;
}